// https://www.shadertoy.com/view/DtXfDr

#define S smoothstep

vec4 Line(vec2 uv, float speed, float height, vec3 col) {
    uv.y += S(0.9, 0., abs(uv.x)) * sin(iTime * speed + uv.x * height) * .3;
    return vec4(S(.05 * S(.2, .9, abs(uv.x)), 0., abs(uv.y) - .004) * col, 1.0) * S(1., .3, abs(uv.x));
}

void mainImage(out vec4 O, in vec2 I) {
    vec2 uv = (I - .5 * iResolution.xy) / iResolution.y;
    O = vec4 (0.);
    for (float i = 0.; i <= 5.; i += 1.) {
        float t = i / 5.;
        O += Line(uv, 0.0002 + t, 6. + t, vec3(.2 + t * .7, .2 + t * .4, 0.3));
    }
}