//  https://www.shadertoy.com/view/XsVSWG
//
// inspired from https://www.shadertoy.com/view/MsGXWy


/**/     // 197 chars

#define R(r)  fract( 4e4 * sin(2e3 * r) )  // random uniform [0,1[

void mainImage( out vec4 O, vec2 U )
{
    O -= O;
    
    for (float i = 0.; i < 2e2; i ++)
        O += R(i)/ 1e3         // pos = pos(0)  +  velocity   *  t   ( modulo, to fit screen )
               / length( fract( R(i+vec2(.1,.2)) + (R(i+vec2(.3,.5))-.5) * iTime/20. ) 
                         - U/iResolution.x );
    // --- colors
  O *= vec4(.5,.2,.1,1);
  O *= vec4(1,O.x,O.x*O.x,1);
  //O = sin(40./O); // just for fun
}
/**/




/**      // 208 chars

#define R(r)  fract( 4e4 * sin(2e3 * r) )

void mainImage(out vec4 O, vec2 U )
{
    O -= O;
    
    for (float i = 0.; i < 2e2; i ++)
        O += max( 0., 
                  1.- length( fract( R(i+vec2(.1,.2)) + (R(i+vec2(.3,.5))-.5) * iTime/20. ) 
                              - U/iResolution.x
                            ) / R(i) * 2e2
                );
}
/**/